// Sygnalizator ding-dong
// ATtiny13, wyczony CKDIV8 + ustawiony BOD 4,3V
// Micha Kurzela @ 2018

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#define WYZW_0 bit_is_clear(PINB,PINB4) //wejcie wyzwalajce (TRIGGER)

#define PULSE_1 PORTB|=(1<<PORTB3) //wyjcie na tranzystor
#define PULSE_0 PORTB&=~(1<<PORTB3)

volatile uint8_t rozdz_pwm; //rozdzielczo w danej fazie brzmienia
volatile uint8_t wart_pwm = 0; //warto PWMu w danej chwili, zmieniana w ptli gwnej
volatile uint8_t licznik = 0; //aktualnie odliczona warto na potrzeby realizacji PWM

//=================================================

ISR(TIM0_OVF_vect){
	if(wart_pwm){licznik++;} //inkrementuj warto licznika, jeeli jest zadana warto grna

	if(licznik > rozdz_pwm){licznik = 0;} //przepenienie licznika

	if(licznik > wart_pwm){PULSE_1;} else {PULSE_0;} //programowa realizacja PWM
}

int main(void){

DDRB = 0b11101111; //konfiguracja we/wy
PORTB = 0b11100111; //wejcie TRIGGER jest Hi-Z, poniewa ma zewntrzny rezystor podcigajcy

//Timer0 zgosi przerwania z czstotliwoci 9,6MHz / 256 = 37500Hz (bez preskalera)
TCCR0B |= (1 << CS00);
TIMSK0 |= (1 << TOIE0);

sei(); //aktywacja systemu przerwa

while(1){
if(WYZW_0){ //wejcie TRIGGER aktywuje si stanem niskim

	rozdz_pwm = 57; //dwik "ding"
	for(wart_pwm = rozdz_pwm/2 ; wart_pwm < 47 ; wart_pwm++){ _delay_ms(45); } //dwik powoli cichnie

	rozdz_pwm = 68; //dwik "dong"
	for(wart_pwm = rozdz_pwm/2 ; wart_pwm < 68 ; wart_pwm++){ _delay_ms(35); if(wart_pwm > 64){_delay_ms(30);}
}


wart_pwm = 0; //wyczenie dwiku
PULSE_0;
licznik = 0;


_delay_ms(1000);


}}}